#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "code.h"
#include "teZZt.h"

// declarations anticipees, contenu en fin de fichier
Arene base;
const char * affichage_base;


// DEBUT DES FONCTIONS DE TESTS
BEGIN_TEST_GROUP(robot)

TEST(OCCURENCES, "") {
    // tous les tests devraient passer
    // si ce n'est pas le cas, vous pouvez commenter
    // ceux qui vous embetent
    REQUIRE( 0 == occurences(NULL     , 'A'));
    REQUIRE( 0 == occurences(""       , 'A'));
    REQUIRE( 1 == occurences("EXAMEN" , 'X'));
    REQUIRE( 2 == occurences("EXAMEN" , 'E'));
    REQUIRE( 0 == occurences("EXAMEN" , '0'));
    REQUIRE( 0 == occurences("EXAMEN" , '\0'));
}

/*
TEST(INITIALISER, "") {

    Arene arene;
    char buffer[3000];
    FILE * file = fmemopen(buffer, 3000, "w");
    
    initialiser(arene);
    arene[4][4]   = 1;
    arene[4][75]  = 2;
    arene[20][75] = 3;
    arene[20][4]  = 4;

    printf("RESULTAT RECHERCHE :\n");
    printf("%s\n", affichage_base);
    printf("VOTRE arene :\n");
    afficher(stdout, arene);
    afficher(file, arene);

    fclose(file);

    REQUIRE( 0 == strcmp(affichage_base, buffer));

}

TEST(LECTURE1, "") {
    Arene arene;
    
    // lecture d'un fichier qui n'existe pas
    int r = lecture("arene00.txt", arene);

    REQUIRE( 0 == r);    
}

TEST(LECTURE2, "") {
    Arene arene;

    // le fichier existe et contient l'arene test
    int r = lecture("arene01.txt", arene);

    afficher(stdout, arene);

    printf("LECTURE %d\n", r);
    REQUIRE( 1 == r);

    // le tableau lu et le tableau "base" sont identiques
    CHECK( 0 == memcmp(base, arene, sizeof(int)*MAXY*MAXX));

}

TEST(TRAJECTOIRE_SIMPLE, "") {
    char buffer[3000];
    FILE * file = fmemopen(buffer, 3000, "w");
    
    Photo  p;
    
    calculer_trajectoire(base, p, 3, 0, 1);
    
    printf("TRAJECTOIRE SIMPLE\n");
    afficher_trajectoire(stdout, base, p);
    afficher_trajectoire(file, base, p);

    fclose(file);

    printf("Ocurrences %d\n", occurences(buffer, 'O'));
    REQUIRE( MAXX == occurences(buffer, 'O'));
}

TEST(TRAJECTOIRE_MORCEAU, "") {
    char buffer[3000];
    FILE * file = fmemopen(buffer, 3000, "w");

    Arene g = { [3][50] = 2 };
    Photo  p;
    
    calculer_trajectoire(g, p, 3, 0, 1);
    
    printf("TRAJECTOIRE MORCEAU\n");
    afficher_trajectoire(stdout, g, p);
    afficher_trajectoire(file, base, p);

    fclose(file);
 
    printf("Ocurrences %d\n", occurences(buffer, 'O'));
    REQUIRE( 65 < occurences(buffer, 'O'));
    REQUIRE( occurences(buffer, 'O') < 75 );
}

TEST(TRAJECTOIRE_CYCLE, "") {
    char buffer[3000];
    FILE * file = fmemopen(buffer, 3000, "w");

    Photo  p;
    
    calculer_trajectoire(base, p, 0, 4, 2);
    
    printf("TRAJECTOIRE CYCLE\n");
    afficher_trajectoire(stdout, base, p);
    afficher_trajectoire(file, base, p);

    fclose(file);
    printf("Ocurrences %d\n", occurences(buffer, 'O'));

    REQUIRE( 170 < occurences(buffer, 'O'));
    REQUIRE( occurences(buffer, 'O') < 180 );
}

TEST(TRAJECTOIRE_CROISEMENT, "") {
    char buffer[3000];
    FILE * file = fmemopen(buffer, 3000, "w");

    Photo  p;
    
    base[20][30] = 4;

    calculer_trajectoire(base, p, 0, 4, 2);
    
    printf("TRAJECTOIRE CYCLE\n");
    afficher_trajectoire(stdout, base, p);
    afficher_trajectoire(file, base, p);

    fclose(file);
    printf("Ocurrence %d\n", occurences(buffer, 'O'));

    REQUIRE( 150 < occurences(buffer, 'O'));
    REQUIRE( occurences(buffer, 'O') < 160 );
}

TEST(LISTE1) {
    char buffer[3000];
    FILE * file = fmemopen(buffer, 3000, "w");

    Arene arene;
    Cellule * tete = NULL;
    
    ajouterListe(&tete, 4, 4,  1);
    ajouterListe(&tete, 4, 75, 2);
    ajouterListe(&tete, 20,75, 3);
    ajouterListe(&tete, 20, 4, 4);
    
    initialiser(arene);
    genererArene(tete, arene);

    printf("ARENE A PARTIR DE LA LISTE \n");
    afficher(stdout, arene);
    afficher(file, arene);

    fclose(file);

    REQUIRE( 0 == strcmp(affichage_base, buffer));

    libererListe(&tete);
}
*/

END_TEST_GROUP(robot)


int main() {
    RUN_TEST_GROUP(robot); 
 
   return 0;
}


// "Designated initializer"
// pas toujours standard dans certaines formes
Arene base = {[4][4] = 1, [4][75]  = 2, [20][75] = 3, [20][4]  = 4};

const char * affichage_base =
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X    >                                                                      T    X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X    ^                                                                      <    X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"X                                                                                X\n"
"XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX\n";
// 26 * 83 caracteres